# -*- coding: utf-8 -*-

"""
ctddocumentation

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from ctddocumentation.api_helper import APIHelper
from ctddocumentation.configuration import Server
from ctddocumentation.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from ctddocumentation.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from apimatic_core.authentication.multiple.and_auth_group import And
from apimatic_core.authentication.multiple.or_auth_group import Or
from ctddocumentation.models.activities_response import ActivitiesResponse


class ActivitiesController(BaseController):

    """A Controller to access Endpoints in the ctddocumentation API."""
    def __init__(self, config):
        super(ActivitiesController, self).__init__(config)

    def get_activities(self,
                       page=None,
                       per_page=None,
                       alert_id__exact=None,
                       asset_reference__exact=None,
                       baseline__exact=None,
                       site__exact=None,
                       asset__exact=None,
                       message__exact=None,
                       comment__exact=None,
                       id__exact=None,
                       site_id__exact=None,
                       type__exact=None,
                       timestamp__exact=None,
                       user_id__exact=None,
                       sort=None):
        """Does a GET request to /ranger/activities.

        Get Activities

        Args:
            page (int, optional): TODO: type description here.
            per_page (int, optional): TODO: type description here.
            alert_id__exact (string, optional): TODO: type description here.
            asset_reference__exact (string, optional): TODO: type description
                here.
            baseline__exact (string, optional): TODO: type description here.
            site__exact (string, optional): TODO: type description here.
            asset__exact (string, optional): TODO: type description here.
            message__exact (string, optional): TODO: type description here.
            comment__exact (string, optional): TODO: type description here.
            id__exact (int, optional): TODO: type description here.
            site_id__exact (int, optional): TODO: type description here.
            type__exact (int, optional): TODO: type description here.
            timestamp__exact (string, optional): TODO: type description here.
            user_id__exact (int, optional): TODO: type description here.
            sort (Sort41Enum, optional): Sort order: add - for descending
                order

        Returns:
            ActivitiesResponse: Response from the API. Successful Operation

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/ranger/activities')
            .http_method(HttpMethodEnum.GET)
            .query_param(Parameter()
                         .key('page')
                         .value(page))
            .query_param(Parameter()
                         .key('per_page')
                         .value(per_page))
            .query_param(Parameter()
                         .key('alert_id__exact')
                         .value(alert_id__exact))
            .query_param(Parameter()
                         .key('asset_reference__exact')
                         .value(asset_reference__exact))
            .query_param(Parameter()
                         .key('baseline__exact')
                         .value(baseline__exact))
            .query_param(Parameter()
                         .key('site__exact')
                         .value(site__exact))
            .query_param(Parameter()
                         .key('asset__exact')
                         .value(asset__exact))
            .query_param(Parameter()
                         .key('message__exact')
                         .value(message__exact))
            .query_param(Parameter()
                         .key('comment__exact')
                         .value(comment__exact))
            .query_param(Parameter()
                         .key('id__exact')
                         .value(id__exact))
            .query_param(Parameter()
                         .key('site_id__exact')
                         .value(site_id__exact))
            .query_param(Parameter()
                         .key('type__exact')
                         .value(type__exact))
            .query_param(Parameter()
                         .key('timestamp__exact')
                         .value(timestamp__exact))
            .query_param(Parameter()
                         .key('user_id__exact')
                         .value(user_id__exact))
            .query_param(Parameter()
                         .key('sort')
                         .value(sort))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(ActivitiesResponse.from_dictionary)
        ).execute()
